SystemOrganization addCategory: #'SeasideOverflow-Model'!
SystemOrganization addCategory: #'SeasideOverflow-Test'!
SystemOrganization addCategory: #'SeasideOverflow-View'!

Object subclass: #Entry
	instanceVariableNames: 'text user votes date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!Entry commentStamp: 'FredHsu 7/3/2012 23:15' prior: 0!
Entry a superclass for questions and answers

Instance Variables:
	text	<ProtoObject | PseudoContext>
	user	<ProtoObject | PseudoContext>
	votes	<Number>
	date	<Date>!

Entry subclass: #Answer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!Answer commentStamp: 'FredHsu 7/3/2012 21:41' prior: 0!
An answer to a question!

!Entry class methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:20'!
by: aUser with: someText
	^self new by: aUser with: someText.! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:19'!
by: aUser with: someText
	user := aUser.
	date := Date today.
	text := someText.
	votes := 0.
	! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:10'!
date
	^date! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:11'!
downVote
	votes := votes - 1! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:23'!
text
	^text! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:10'!
upVote
	votes := votes + 1! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:09'!
user
	^user! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:09'!
votes
	^votes! !

Entry subclass: #Question
	instanceVariableNames: 'answers views tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!Question commentStamp: 'FredHsu 7/3/2012 21:41' prior: 0!
A question posed by a user!

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:32'!
addAnswer: anAnswer
	answers add: anAnswer.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:25'!
addTag: aTag
	tags add: aTag.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:23'!
answers
	^answers! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:28'!
by: aUser with: someText
	super by: aUser with: someText.
	answers := OrderedCollection new.
	views := 0.
	tags := Set new.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:28'!
hasTag: aTag
	^tags includes: aTag.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:24'!
incrementViews 
	views := views + 1.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:29'!
removeTag: aTag
	tags remove: aTag.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:23'!
tags
	^tags! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:23'!
views
	^views! !

TestCase subclass: #AnswerTest
	instanceVariableNames: 'anAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Test'!

!AnswerTest class methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:09'!
testBy
	| anAnswer |
	anAnswer := Answer by: 'Fred Hsu'.
	self assert: (anAnswer user) = 'Fred Hsu'.
	self assert: (anAnswer votes) = 0.! !

!AnswerTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:23'!
setUp
	| user answerText |
	super setUp.
	user := 'Fred Hsu'.
	answerText := '42'.
	anAnswer := Answer by: user with: answerText.! !

!AnswerTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:22'!
testByWith
	| ans user answerText|
	user := 'Fred Hsu'.
	answerText := 'This is my answer.'.
	ans := Answer by: user with: answerText.
	self assert: (ans user) = user.
	self assert: (ans votes) = 0.
	self assert: (ans text) = answerText.! !

!AnswerTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:17'!
testUpDownVote
	anAnswer upVote.
	self assert: anAnswer votes = 1.
	anAnswer upVote.
	self assert: anAnswer votes = 2.
	anAnswer downVote.
	self assert: anAnswer votes = 1.
	anAnswer downVote.
	self assert: anAnswer votes = 0.
	anAnswer downVote.
	self assert: anAnswer votes = -1.
! !

TestCase subclass: #QuestionListingTest
	instanceVariableNames: 'questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Test'!

!QuestionListingTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:36'!
setUp! !

!QuestionListingTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:33'!
testAdd
! !

!QuestionListingTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:33'!
testRemove
! !

TestCase subclass: #QuestionTest
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Test'!

!QuestionTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:08'!
setUp
	| user questionText  |
	super setUp.
	user := 'Fred Hsu'.
	questionText := 'What is the meaning to life, the universe, and everything?'.
	question := Question by: user with: questionText.! !

!QuestionTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:36'!
testAddAnswer
	| answer1 answer2 answer3 |
	answer1 := Answer by: 'user1' with: 'answerText1'.
	answer2 := Answer by: 'user2' with: 'answerText2'.
	answer3 := Answer by: 'user3' with: 'answerText3'.
	question addAnswer: answer1.
	self assert: (question answers includes: answer1).
	question addAnswer: answer2.
	self assert: (question answers includes: answer2).
	question addAnswer: answer3.	
	self assert: (question answers includes: answer3).
! !

!QuestionTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:31'!
testAddRemoveTags
	question addTag: 'foo'.
	self assert: (question hasTag: 'foo').
	question removeTag: 'foo'.
	self assert: ((question hasTag: 'foo') not).! !

!QuestionTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:13'!
testIncrementViews
	self assert: question views = 0.
	question incrementViews.
	self assert: question views = 1.
	question incrementViews.
	self assert: question views = 2.! !

WAComponent subclass: #QuestionListing
	instanceVariableNames: 'questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!QuestionListing commentStamp: 'FredHsu 7/3/2012 23:15' prior: 0!
QuestionListing is a list of questions on the system

	questions	<ProtoObject | PseudoContext>!

!QuestionListing methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:17'!
initialize
	super initialize.
	questions := SortedCollection new.! !
